// Copyright (c) Microsoft Corporation.
// Licensed under the MIT license.
import { getClient } from "@azure-rest/core-client";
/**
 * Initialize a new instance of the class AnomalyDetectorRestClient class.
 * @param Endpoint type: string
 * @param credentials type: KeyCredential
 */
export default function createClient(Endpoint, credentials, options = {}) {
    var _a, _b;
    const ApiVersion = (_a = options.ApiVersion) !== null && _a !== void 0 ? _a : "v1.1";
    const baseUrl = (_b = options.baseUrl) !== null && _b !== void 0 ? _b : `${Endpoint}/anomalydetector/${ApiVersion}`;
    options = Object.assign(Object.assign({}, options), { credentials: {
            apiKeyHeaderName: "Ocp-Apim-Subscription-Key",
        } });
    const userAgentInfo = `azsdk-js-ai-anomaly-detector-rest/1.0.0-beta.1`;
    const userAgentPrefix = options.userAgentOptions && options.userAgentOptions.userAgentPrefix
        ? `${options.userAgentOptions.userAgentPrefix} ${userAgentInfo}`
        : `${userAgentInfo}`;
    options = Object.assign(Object.assign({}, options), { userAgentOptions: {
            userAgentPrefix,
        } });
    const client = getClient(baseUrl, credentials, options);
    return client;
}
//# sourceMappingURL=anomalyDetectorRest.js.map