## API Report File for "@azure-rest/ai-anomaly-detector"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { Client } from '@azure-rest/core-client';
import { ClientOptions } from '@azure-rest/core-client';
import { HttpResponse } from '@azure-rest/core-client';
import { KeyCredential } from '@azure/core-auth';
import { PagedAsyncIterableIterator } from '@azure/core-paging';
import { PathUncheckedResponse } from '@azure-rest/core-client';
import { RawHttpHeaders } from '@azure/core-rest-pipeline';
import { RequestParameters } from '@azure-rest/core-client';
import { StreamableMethod } from '@azure-rest/core-client';

// @public
export interface AlignPolicy {
    alignMode?: "Inner" | "Outer";
    fillNAMethod?: string;
    paddingValue?: number;
}

// @public
export interface AlignPolicyOutput {
    alignMode?: "Inner" | "Outer";
    fillNAMethod?: string;
    paddingValue?: number;
}

// @public
export interface AnomalyDetectionModelOutput {
    createdTime: string;
    lastUpdatedTime: string;
    modelId: string;
    modelInfo?: ModelInfoOutput;
}

// @public
export interface AnomalyDetectorErrorOutput {
    code?: string;
    message?: string;
}

// @public (undocumented)
export type AnomalyDetectorRestClient = Client & {
    path: Routes;
};

// @public (undocumented)
export interface AnomalyDetectorRestClientOptions extends ClientOptions {
    // (undocumented)
    ApiVersion?: string;
}

// @public
export interface AnomalyInterpretationOutput {
    contributionScore?: number;
    correlationChanges?: CorrelationChangesOutput;
    variable?: string;
}

// @public
export interface AnomalyStateOutput {
    errors?: Array<ErrorResponseOutput>;
    timestamp: string;
    value?: AnomalyValueOutput;
}

// @public
export interface AnomalyValueOutput {
    interpretation?: Array<AnomalyInterpretationOutput>;
    isAnomaly: boolean;
    score: number;
    severity: number;
}

// @public
export interface CorrelationChangesOutput {
    changedVariables?: string[];
}

// @public
function createClient(Endpoint: string, credentials: KeyCredential, options?: AnomalyDetectorRestClientOptions): AnomalyDetectorRestClient;
export default createClient;

// @public (undocumented)
export interface DeleteMultivariateModel {
    delete(options?: DeleteMultivariateModelParameters): StreamableMethod<DeleteMultivariateModel204Response | DeleteMultivariateModelDefaultResponse>;
    get(options?: GetMultivariateModelParameters): StreamableMethod<GetMultivariateModel200Response | GetMultivariateModelDefaultResponse>;
}

// @public
export interface DeleteMultivariateModel204Response extends HttpResponse {
    // (undocumented)
    status: "204";
}

// @public (undocumented)
export interface DeleteMultivariateModelDefaultHeaders {
    "x-ms-error-code"?: string;
}

// @public (undocumented)
export interface DeleteMultivariateModelDefaultResponse extends HttpResponse {
    // (undocumented)
    body: ErrorResponseOutput;
    // (undocumented)
    headers: RawHttpHeaders & DeleteMultivariateModelDefaultHeaders;
    // (undocumented)
    status: string;
}

// @public (undocumented)
export type DeleteMultivariateModelParameters = RequestParameters;

// @public (undocumented)
export interface DetectMultivariateBatchAnomaly {
    post(options: DetectMultivariateBatchAnomalyParameters): StreamableMethod<DetectMultivariateBatchAnomaly202Response | DetectMultivariateBatchAnomalyDefaultResponse>;
}

// @public (undocumented)
export interface DetectMultivariateBatchAnomaly202Headers {
    "operation-id": string;
    "operation-location": string;
}

// @public
export interface DetectMultivariateBatchAnomaly202Response extends HttpResponse {
    // (undocumented)
    body: MultivariateDetectionResultOutput;
    // (undocumented)
    headers: RawHttpHeaders & DetectMultivariateBatchAnomaly202Headers;
    // (undocumented)
    status: "202";
}

// @public (undocumented)
export interface DetectMultivariateBatchAnomalyBodyParam {
    body: MultivariateBatchDetectionOptions;
}

// @public (undocumented)
export interface DetectMultivariateBatchAnomalyDefaultHeaders {
    "x-ms-error-code"?: string;
}

// @public (undocumented)
export interface DetectMultivariateBatchAnomalyDefaultResponse extends HttpResponse {
    // (undocumented)
    body: ErrorResponseOutput;
    // (undocumented)
    headers: RawHttpHeaders & DetectMultivariateBatchAnomalyDefaultHeaders;
    // (undocumented)
    status: string;
}

// @public (undocumented)
export type DetectMultivariateBatchAnomalyParameters = DetectMultivariateBatchAnomalyBodyParam & RequestParameters;

// @public (undocumented)
export interface DetectMultivariateLastAnomaly {
    post(options: DetectMultivariateLastAnomalyParameters): StreamableMethod<DetectMultivariateLastAnomaly200Response | DetectMultivariateLastAnomalyDefaultResponse>;
}

// @public
export interface DetectMultivariateLastAnomaly200Response extends HttpResponse {
    // (undocumented)
    body: MultivariateLastDetectionResultOutput;
    // (undocumented)
    status: "200";
}

// @public (undocumented)
export interface DetectMultivariateLastAnomalyBodyParam {
    body: MultivariateLastDetectionOptions;
}

// @public (undocumented)
export interface DetectMultivariateLastAnomalyDefaultHeaders {
    "x-ms-error-code"?: string;
}

// @public (undocumented)
export interface DetectMultivariateLastAnomalyDefaultResponse extends HttpResponse {
    // (undocumented)
    body: ErrorResponseOutput;
    // (undocumented)
    headers: RawHttpHeaders & DetectMultivariateLastAnomalyDefaultHeaders;
    // (undocumented)
    status: string;
}

// @public (undocumented)
export type DetectMultivariateLastAnomalyParameters = DetectMultivariateLastAnomalyBodyParam & RequestParameters;

// @public (undocumented)
export interface DetectUnivariateChangePoint {
    post(options: DetectUnivariateChangePointParameters): StreamableMethod<DetectUnivariateChangePoint200Response | DetectUnivariateChangePointDefaultResponse>;
}

// @public
export interface DetectUnivariateChangePoint200Response extends HttpResponse {
    // (undocumented)
    body: UnivariateChangePointDetectionResultOutput;
    // (undocumented)
    status: "200";
}

// @public (undocumented)
export interface DetectUnivariateChangePointBodyParam {
    body: UnivariateChangePointDetectionOptions;
}

// @public (undocumented)
export interface DetectUnivariateChangePointDefaultHeaders {
    "x-ms-error-code"?: string;
}

// @public (undocumented)
export interface DetectUnivariateChangePointDefaultResponse extends HttpResponse {
    // (undocumented)
    body: AnomalyDetectorErrorOutput;
    // (undocumented)
    headers: RawHttpHeaders & DetectUnivariateChangePointDefaultHeaders;
    // (undocumented)
    status: string;
}

// @public (undocumented)
export type DetectUnivariateChangePointParameters = DetectUnivariateChangePointBodyParam & RequestParameters;

// @public (undocumented)
export interface DetectUnivariateEntireSeries {
    post(options: DetectUnivariateEntireSeriesParameters): StreamableMethod<DetectUnivariateEntireSeries200Response | DetectUnivariateEntireSeriesDefaultResponse>;
}

// @public
export interface DetectUnivariateEntireSeries200Response extends HttpResponse {
    // (undocumented)
    body: UnivariateEntireDetectionResultOutput;
    // (undocumented)
    status: "200";
}

// @public (undocumented)
export interface DetectUnivariateEntireSeriesBodyParam {
    body: UnivariateDetectionOptions;
}

// @public (undocumented)
export interface DetectUnivariateEntireSeriesDefaultHeaders {
    "x-ms-error-code"?: string;
}

// @public (undocumented)
export interface DetectUnivariateEntireSeriesDefaultResponse extends HttpResponse {
    // (undocumented)
    body: AnomalyDetectorErrorOutput;
    // (undocumented)
    headers: RawHttpHeaders & DetectUnivariateEntireSeriesDefaultHeaders;
    // (undocumented)
    status: string;
}

// @public (undocumented)
export type DetectUnivariateEntireSeriesParameters = DetectUnivariateEntireSeriesBodyParam & RequestParameters;

// @public (undocumented)
export interface DetectUnivariateLastPoint {
    post(options: DetectUnivariateLastPointParameters): StreamableMethod<DetectUnivariateLastPoint200Response | DetectUnivariateLastPointDefaultResponse>;
}

// @public
export interface DetectUnivariateLastPoint200Response extends HttpResponse {
    // (undocumented)
    body: UnivariateLastDetectionResultOutput;
    // (undocumented)
    status: "200";
}

// @public (undocumented)
export interface DetectUnivariateLastPointBodyParam {
    body: UnivariateDetectionOptions;
}

// @public (undocumented)
export interface DetectUnivariateLastPointDefaultHeaders {
    "x-ms-error-code"?: string;
}

// @public (undocumented)
export interface DetectUnivariateLastPointDefaultResponse extends HttpResponse {
    // (undocumented)
    body: AnomalyDetectorErrorOutput;
    // (undocumented)
    headers: RawHttpHeaders & DetectUnivariateLastPointDefaultHeaders;
    // (undocumented)
    status: string;
}

// @public (undocumented)
export type DetectUnivariateLastPointParameters = DetectUnivariateLastPointBodyParam & RequestParameters;

// @public
export interface DiagnosticsInfo {
    modelState?: ModelState;
    variableStates?: Array<VariableState>;
}

// @public
export interface DiagnosticsInfoOutput {
    modelState?: ModelStateOutput;
    variableStates?: Array<VariableStateOutput>;
}

// @public
export interface ErrorResponse {
    code: string;
    message: string;
}

// @public
export interface ErrorResponseOutput {
    code: string;
    message: string;
}

// @public
export type GetArrayType<T> = T extends Array<infer TData> ? TData : never;

// @public (undocumented)
export interface GetMultivariateBatchDetectionResult {
    get(options?: GetMultivariateBatchDetectionResultParameters): StreamableMethod<GetMultivariateBatchDetectionResult200Response | GetMultivariateBatchDetectionResultDefaultResponse>;
}

// @public
export interface GetMultivariateBatchDetectionResult200Response extends HttpResponse {
    // (undocumented)
    body: MultivariateDetectionResultOutput;
    // (undocumented)
    status: "200";
}

// @public (undocumented)
export interface GetMultivariateBatchDetectionResultDefaultHeaders {
    "x-ms-error-code"?: string;
}

// @public (undocumented)
export interface GetMultivariateBatchDetectionResultDefaultResponse extends HttpResponse {
    // (undocumented)
    body: ErrorResponseOutput;
    // (undocumented)
    headers: RawHttpHeaders & GetMultivariateBatchDetectionResultDefaultHeaders;
    // (undocumented)
    status: string;
}

// @public (undocumented)
export type GetMultivariateBatchDetectionResultParameters = RequestParameters;

// @public
export interface GetMultivariateModel200Response extends HttpResponse {
    // (undocumented)
    body: AnomalyDetectionModelOutput;
    // (undocumented)
    status: "200";
}

// @public (undocumented)
export interface GetMultivariateModelDefaultHeaders {
    "x-ms-error-code"?: string;
}

// @public (undocumented)
export interface GetMultivariateModelDefaultResponse extends HttpResponse {
    // (undocumented)
    body: ErrorResponseOutput;
    // (undocumented)
    headers: RawHttpHeaders & GetMultivariateModelDefaultHeaders;
    // (undocumented)
    status: string;
}

// @public (undocumented)
export type GetMultivariateModelParameters = RequestParameters;

// @public
export type GetPage<TPage> = (pageLink: string, maxPageSize?: number) => Promise<{
    page: TPage;
    nextPageLink?: string;
}>;

// @public (undocumented)
export function isUnexpected(response: DetectUnivariateEntireSeries200Response | DetectUnivariateEntireSeriesDefaultResponse): response is DetectUnivariateEntireSeriesDefaultResponse;

// @public (undocumented)
export function isUnexpected(response: DetectUnivariateLastPoint200Response | DetectUnivariateLastPointDefaultResponse): response is DetectUnivariateLastPointDefaultResponse;

// @public (undocumented)
export function isUnexpected(response: DetectUnivariateChangePoint200Response | DetectUnivariateChangePointDefaultResponse): response is DetectUnivariateChangePointDefaultResponse;

// @public (undocumented)
export function isUnexpected(response: GetMultivariateBatchDetectionResult200Response | GetMultivariateBatchDetectionResultDefaultResponse): response is GetMultivariateBatchDetectionResultDefaultResponse;

// @public (undocumented)
export function isUnexpected(response: TrainMultivariateModel201Response | TrainMultivariateModelDefaultResponse): response is TrainMultivariateModelDefaultResponse;

// @public (undocumented)
export function isUnexpected(response: ListMultivariateModels200Response | ListMultivariateModelsDefaultResponse): response is ListMultivariateModelsDefaultResponse;

// @public (undocumented)
export function isUnexpected(response: DeleteMultivariateModel204Response | DeleteMultivariateModelDefaultResponse): response is DeleteMultivariateModelDefaultResponse;

// @public (undocumented)
export function isUnexpected(response: GetMultivariateModel200Response | GetMultivariateModelDefaultResponse): response is GetMultivariateModelDefaultResponse;

// @public (undocumented)
export function isUnexpected(response: DetectMultivariateBatchAnomaly202Response | DetectMultivariateBatchAnomalyDefaultResponse): response is DetectMultivariateBatchAnomalyDefaultResponse;

// @public (undocumented)
export function isUnexpected(response: DetectMultivariateLastAnomaly200Response | DetectMultivariateLastAnomalyDefaultResponse): response is DetectMultivariateLastAnomalyDefaultResponse;

// @public
export interface ListMultivariateModels200Response extends HttpResponse {
    // (undocumented)
    body: ModelListOutput;
    // (undocumented)
    status: "200";
}

// @public (undocumented)
export interface ListMultivariateModelsDefaultHeaders {
    "x-ms-error-code"?: string;
}

// @public (undocumented)
export interface ListMultivariateModelsDefaultResponse extends HttpResponse {
    // (undocumented)
    body: ErrorResponseOutput;
    // (undocumented)
    headers: RawHttpHeaders & ListMultivariateModelsDefaultHeaders;
    // (undocumented)
    status: string;
}

// @public (undocumented)
export type ListMultivariateModelsParameters = ListMultivariateModelsQueryParam & RequestParameters;

// @public (undocumented)
export interface ListMultivariateModelsQueryParam {
    // (undocumented)
    queryParameters?: ListMultivariateModelsQueryParamProperties;
}

// @public (undocumented)
export interface ListMultivariateModelsQueryParamProperties {
    skip?: number;
    top?: number;
}

// @public
export interface ModelInfo {
    alignPolicy?: AlignPolicy;
    dataSchema?: string;
    dataSource: string;
    diagnosticsInfo?: DiagnosticsInfo;
    displayName?: string;
    endTime: Date | string;
    slidingWindow?: number;
    startTime: Date | string;
    status?: "CREATED" | "RUNNING" | "READY" | "FAILED";
}

// @public
export interface ModelInfoOutput {
    alignPolicy?: AlignPolicyOutput;
    dataSchema?: string;
    dataSource: string;
    diagnosticsInfo?: DiagnosticsInfoOutput;
    displayName?: string;
    endTime: string;
    readonly errors?: Array<ErrorResponseOutput>;
    slidingWindow?: number;
    startTime: string;
    status?: "CREATED" | "RUNNING" | "READY" | "FAILED";
}

// @public
export interface ModelListOutput {
    currentCount: number;
    maxCount: number;
    models: Array<AnomalyDetectionModelOutput>;
    nextLink?: string;
}

// @public
export interface ModelState {
    epochIds?: number[];
    latenciesInSeconds?: number[];
    trainLosses?: number[];
    validationLosses?: number[];
}

// @public
export interface ModelStateOutput {
    epochIds?: number[];
    latenciesInSeconds?: number[];
    trainLosses?: number[];
    validationLosses?: number[];
}

// @public
export interface MultivariateBatchDetectionOptions {
    dataSource: string;
    endTime: Date | string;
    startTime: Date | string;
    topContributorCount: number;
}

// @public
export interface MultivariateBatchDetectionOptionsOutput {
    dataSource: string;
    endTime: string;
    startTime: string;
    topContributorCount: number;
}

// @public
export interface MultivariateBatchDetectionResultSummaryOutput {
    errors?: Array<ErrorResponseOutput>;
    setupInfo: MultivariateBatchDetectionOptionsOutput;
    status: "CREATED" | "RUNNING" | "READY" | "FAILED";
    variableStates?: Array<VariableStateOutput>;
}

// @public
export interface MultivariateDetectionResultOutput {
    resultId: string;
    results: Array<AnomalyStateOutput>;
    summary: MultivariateBatchDetectionResultSummaryOutput;
}

// @public
export interface MultivariateLastDetectionOptions {
    topContributorCount: number;
    variables: Array<VariableValues>;
}

// @public
export interface MultivariateLastDetectionResultOutput {
    results?: Array<AnomalyStateOutput>;
    variableStates?: Array<VariableStateOutput>;
}

// @public
export function paginate<TResponse extends PathUncheckedResponse>(client: Client, initialResponse: TResponse, options?: PagingOptions<TResponse>): PagedAsyncIterableIterator<PaginateReturn<TResponse>>;

// @public
export type PaginateReturn<TResult> = TResult extends {
    body: {
        value?: infer TPage;
    };
} | {
    body: {
        models?: infer TPage;
    };
} ? GetArrayType<TPage> : Array<unknown>;

// @public
export interface PagingOptions<TResponse> {
    customGetPage?: GetPage<PaginateReturn<TResponse>[]>;
}

// @public (undocumented)
export interface Routes {
    (path: "/timeseries/entire/detect"): DetectUnivariateEntireSeries;
    (path: "/timeseries/last/detect"): DetectUnivariateLastPoint;
    (path: "/timeseries/changepoint/detect"): DetectUnivariateChangePoint;
    (path: "/multivariate/detect-batch/{resultId}", resultId: string): GetMultivariateBatchDetectionResult;
    (path: "/multivariate/models"): TrainMultivariateModel;
    (path: "/multivariate/models/{modelId}", modelId: string): DeleteMultivariateModel;
    (path: "/multivariate/models/{modelId}:detect-batch", modelId: string): DetectMultivariateBatchAnomaly;
    (path: "/multivariate/models/{modelId}:detect-last", modelId: string): DetectMultivariateLastAnomaly;
}

// @public
export interface TimeSeriesPoint {
    timestamp?: Date | string;
    value: number;
}

// @public (undocumented)
export interface TrainMultivariateModel {
    get(options?: ListMultivariateModelsParameters): StreamableMethod<ListMultivariateModels200Response | ListMultivariateModelsDefaultResponse>;
    post(options: TrainMultivariateModelParameters): StreamableMethod<TrainMultivariateModel201Response | TrainMultivariateModelDefaultResponse>;
}

// @public (undocumented)
export interface TrainMultivariateModel201Headers {
    location: string;
}

// @public
export interface TrainMultivariateModel201Response extends HttpResponse {
    // (undocumented)
    body: AnomalyDetectionModelOutput;
    // (undocumented)
    headers: RawHttpHeaders & TrainMultivariateModel201Headers;
    // (undocumented)
    status: "201";
}

// @public (undocumented)
export interface TrainMultivariateModelBodyParam {
    body: ModelInfo;
}

// @public (undocumented)
export interface TrainMultivariateModelDefaultHeaders {
    "x-ms-error-code"?: string;
}

// @public (undocumented)
export interface TrainMultivariateModelDefaultResponse extends HttpResponse {
    // (undocumented)
    body: ErrorResponseOutput;
    // (undocumented)
    headers: RawHttpHeaders & TrainMultivariateModelDefaultHeaders;
    // (undocumented)
    status: string;
}

// @public (undocumented)
export type TrainMultivariateModelParameters = TrainMultivariateModelBodyParam & RequestParameters;

// @public
export interface UnivariateChangePointDetectionOptions {
    customInterval?: number;
    granularity: "yearly" | "monthly" | "weekly" | "daily" | "hourly" | "minutely" | "secondly" | "microsecond" | "none";
    period?: number;
    series: Array<TimeSeriesPoint>;
    stableTrendWindow?: number;
    threshold?: number;
}

// @public
export interface UnivariateChangePointDetectionResultOutput {
    confidenceScores?: number[];
    isChangePoint?: boolean[];
    readonly period?: number;
}

// @public
export interface UnivariateDetectionOptions {
    customInterval?: number;
    granularity?: "yearly" | "monthly" | "weekly" | "daily" | "hourly" | "minutely" | "secondly" | "microsecond" | "none";
    imputeFixedValue?: number;
    imputeMode?: string;
    maxAnomalyRatio?: number;
    period?: number;
    sensitivity?: number;
    series: Array<TimeSeriesPoint>;
}

// @public
export interface UnivariateEntireDetectionResultOutput {
    expectedValues: number[];
    isAnomaly: boolean[];
    isNegativeAnomaly: boolean[];
    isPositiveAnomaly: boolean[];
    lowerMargins: number[];
    period: number;
    severity?: number[];
    upperMargins: number[];
}

// @public
export interface UnivariateLastDetectionResultOutput {
    expectedValue: number;
    isAnomaly: boolean;
    isNegativeAnomaly: boolean;
    isPositiveAnomaly: boolean;
    lowerMargin: number;
    period: number;
    severity?: number;
    suggestedWindow: number;
    upperMargin: number;
}

// @public
export interface VariableState {
    effectiveCount?: number;
    filledNARatio?: number;
    firstTimestamp?: Date | string;
    lastTimestamp?: Date | string;
    variable?: string;
}

// @public
export interface VariableStateOutput {
    effectiveCount?: number;
    filledNARatio?: number;
    firstTimestamp?: string;
    lastTimestamp?: string;
    variable?: string;
}

// @public
export interface VariableValues {
    timestamps: string[];
    values: number[];
    variable: string;
}

// (No @packageDocumentation comment for this package)

```
